// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from dvl_msgs:msg/DeadReckoning.idl
// generated code does not contain a copyright notice

#include "dvl_msgs/msg/detail/dead_reckoning__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_dvl_msgs
const rosidl_type_hash_t *
dvl_msgs__msg__DeadReckoning__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xf9, 0x94, 0x4b, 0x51, 0xe7, 0xb0, 0xe8, 0xc8,
      0x7b, 0x4a, 0xc7, 0xec, 0xe5, 0x1e, 0xcd, 0xd5,
      0x93, 0x0f, 0xdb, 0x16, 0xb0, 0x08, 0xa2, 0xf0,
      0x3e, 0x3f, 0x3a, 0x8c, 0x20, 0x93, 0x44, 0x0f,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types
#include "geometry_msgs/msg/detail/vector3__functions.h"

// Hashes for external referenced types
#ifndef NDEBUG
static const rosidl_type_hash_t geometry_msgs__msg__Vector3__EXPECTED_HASH = {1, {
    0xcc, 0x12, 0xfe, 0x83, 0xe4, 0xc0, 0x27, 0x19,
    0xf1, 0xce, 0x80, 0x70, 0xbf, 0xd1, 0x4a, 0xec,
    0xd4, 0x0f, 0x75, 0xa9, 0x66, 0x96, 0xa6, 0x7a,
    0x2a, 0x1f, 0x37, 0xf7, 0xdb, 0xb0, 0x76, 0x5d,
  }};
#endif

static char dvl_msgs__msg__DeadReckoning__TYPE_NAME[] = "dvl_msgs/msg/DeadReckoning";
static char geometry_msgs__msg__Vector3__TYPE_NAME[] = "geometry_msgs/msg/Vector3";

// Define type names, field names, and default values
static char dvl_msgs__msg__DeadReckoning__FIELD_NAME__time_stamp[] = "time_stamp";
static char dvl_msgs__msg__DeadReckoning__FIELD_NAME__distance[] = "distance";
static char dvl_msgs__msg__DeadReckoning__FIELD_NAME__stddev[] = "stddev";
static char dvl_msgs__msg__DeadReckoning__FIELD_NAME__rpy[] = "rpy";
static char dvl_msgs__msg__DeadReckoning__FIELD_NAME__status[] = "status";

static rosidl_runtime_c__type_description__Field dvl_msgs__msg__DeadReckoning__FIELDS[] = {
  {
    {dvl_msgs__msg__DeadReckoning__FIELD_NAME__time_stamp, 10, 10},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_DOUBLE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {dvl_msgs__msg__DeadReckoning__FIELD_NAME__distance, 8, 8},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_NESTED_TYPE,
      0,
      0,
      {geometry_msgs__msg__Vector3__TYPE_NAME, 25, 25},
    },
    {NULL, 0, 0},
  },
  {
    {dvl_msgs__msg__DeadReckoning__FIELD_NAME__stddev, 6, 6},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_DOUBLE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {dvl_msgs__msg__DeadReckoning__FIELD_NAME__rpy, 3, 3},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_NESTED_TYPE,
      0,
      0,
      {geometry_msgs__msg__Vector3__TYPE_NAME, 25, 25},
    },
    {NULL, 0, 0},
  },
  {
    {dvl_msgs__msg__DeadReckoning__FIELD_NAME__status, 6, 6},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

static rosidl_runtime_c__type_description__IndividualTypeDescription dvl_msgs__msg__DeadReckoning__REFERENCED_TYPE_DESCRIPTIONS[] = {
  {
    {geometry_msgs__msg__Vector3__TYPE_NAME, 25, 25},
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
dvl_msgs__msg__DeadReckoning__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {dvl_msgs__msg__DeadReckoning__TYPE_NAME, 26, 26},
      {dvl_msgs__msg__DeadReckoning__FIELDS, 5, 5},
    },
    {dvl_msgs__msg__DeadReckoning__REFERENCED_TYPE_DESCRIPTIONS, 1, 1},
  };
  if (!constructed) {
    assert(0 == memcmp(&geometry_msgs__msg__Vector3__EXPECTED_HASH, geometry_msgs__msg__Vector3__get_type_hash(NULL), sizeof(rosidl_type_hash_t)));
    description.referenced_type_descriptions.data[0].fields = geometry_msgs__msg__Vector3__get_type_description(NULL)->type_description.fields;
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "float64 time_stamp # sensor's unix time stamp in seconds\n"
  "geometry_msgs/Vector3 distance\n"
  "float64 stddev # standard deviation in [m]\n"
  "geometry_msgs/Vector3 rpy # orientation expressed as roll, pitch and yaw angle\n"
  "uint8 status # 0: no errors 1: else";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
dvl_msgs__msg__DeadReckoning__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {dvl_msgs__msg__DeadReckoning__TYPE_NAME, 26, 26},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 246, 246},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
dvl_msgs__msg__DeadReckoning__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[2];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 2, 2};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *dvl_msgs__msg__DeadReckoning__get_individual_type_description_source(NULL),
    sources[1] = *geometry_msgs__msg__Vector3__get_individual_type_description_source(NULL);
    constructed = true;
  }
  return &source_sequence;
}
