// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from dvl_msgs:msg/DeadReckoning.idl
// generated code does not contain a copyright notice

#ifndef DVL_MSGS__MSG__DETAIL__DEAD_RECKONING__STRUCT_H_
#define DVL_MSGS__MSG__DETAIL__DEAD_RECKONING__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'distance'
// Member 'rpy'
#include "geometry_msgs/msg/detail/vector3__struct.h"

/// Struct defined in msg/DeadReckoning in the package dvl_msgs.
typedef struct dvl_msgs__msg__DeadReckoning
{
  /// sensor's unix time stamp in seconds
  double time_stamp;
  geometry_msgs__msg__Vector3 distance;
  /// standard deviation in
  double stddev;
  /// orientation expressed as roll, pitch and yaw angle
  geometry_msgs__msg__Vector3 rpy;
  /// 0: no errors 1: else
  uint8_t status;
} dvl_msgs__msg__DeadReckoning;

// Struct for a sequence of dvl_msgs__msg__DeadReckoning.
typedef struct dvl_msgs__msg__DeadReckoning__Sequence
{
  dvl_msgs__msg__DeadReckoning * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} dvl_msgs__msg__DeadReckoning__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DVL_MSGS__MSG__DETAIL__DEAD_RECKONING__STRUCT_H_
