// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from dvl_msgs:msg/DeadReckoningReport.idl
// generated code does not contain a copyright notice

#ifndef DVL_MSGS__MSG__DETAIL__DEAD_RECKONING_REPORT__TRAITS_HPP_
#define DVL_MSGS__MSG__DETAIL__DEAD_RECKONING_REPORT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "dvl_msgs/msg/detail/dead_reckoning_report__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'report'
#include "dvl_msgs/msg/detail/dead_reckoning__traits.hpp"

namespace dvl_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const DeadReckoningReport & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: report
  {
    out << "report: ";
    to_flow_style_yaml(msg.report, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DeadReckoningReport & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: report
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "report:\n";
    to_block_style_yaml(msg.report, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DeadReckoningReport & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace dvl_msgs

namespace rosidl_generator_traits
{

[[deprecated("use dvl_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const dvl_msgs::msg::DeadReckoningReport & msg,
  std::ostream & out, size_t indentation = 0)
{
  dvl_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use dvl_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const dvl_msgs::msg::DeadReckoningReport & msg)
{
  return dvl_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<dvl_msgs::msg::DeadReckoningReport>()
{
  return "dvl_msgs::msg::DeadReckoningReport";
}

template<>
inline const char * name<dvl_msgs::msg::DeadReckoningReport>()
{
  return "dvl_msgs/msg/DeadReckoningReport";
}

template<>
struct has_fixed_size<dvl_msgs::msg::DeadReckoningReport>
  : std::integral_constant<bool, has_fixed_size<dvl_msgs::msg::DeadReckoning>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<dvl_msgs::msg::DeadReckoningReport>
  : std::integral_constant<bool, has_bounded_size<dvl_msgs::msg::DeadReckoning>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<dvl_msgs::msg::DeadReckoningReport>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // DVL_MSGS__MSG__DETAIL__DEAD_RECKONING_REPORT__TRAITS_HPP_
