// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from dvl_msgs:msg/Transducer.idl
// generated code does not contain a copyright notice

#ifndef DVL_MSGS__MSG__DETAIL__TRANSDUCER__BUILDER_HPP_
#define DVL_MSGS__MSG__DETAIL__TRANSDUCER__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "dvl_msgs/msg/detail/transducer__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace dvl_msgs
{

namespace msg
{

namespace builder
{

class Init_Transducer_nsd
{
public:
  explicit Init_Transducer_nsd(::dvl_msgs::msg::Transducer & msg)
  : msg_(msg)
  {}
  ::dvl_msgs::msg::Transducer nsd(::dvl_msgs::msg::Transducer::_nsd_type arg)
  {
    msg_.nsd = std::move(arg);
    return std::move(msg_);
  }

private:
  ::dvl_msgs::msg::Transducer msg_;
};

class Init_Transducer_rssi
{
public:
  explicit Init_Transducer_rssi(::dvl_msgs::msg::Transducer & msg)
  : msg_(msg)
  {}
  Init_Transducer_nsd rssi(::dvl_msgs::msg::Transducer::_rssi_type arg)
  {
    msg_.rssi = std::move(arg);
    return Init_Transducer_nsd(msg_);
  }

private:
  ::dvl_msgs::msg::Transducer msg_;
};

class Init_Transducer_distance
{
public:
  explicit Init_Transducer_distance(::dvl_msgs::msg::Transducer & msg)
  : msg_(msg)
  {}
  Init_Transducer_rssi distance(::dvl_msgs::msg::Transducer::_distance_type arg)
  {
    msg_.distance = std::move(arg);
    return Init_Transducer_rssi(msg_);
  }

private:
  ::dvl_msgs::msg::Transducer msg_;
};

class Init_Transducer_velocity
{
public:
  explicit Init_Transducer_velocity(::dvl_msgs::msg::Transducer & msg)
  : msg_(msg)
  {}
  Init_Transducer_distance velocity(::dvl_msgs::msg::Transducer::_velocity_type arg)
  {
    msg_.velocity = std::move(arg);
    return Init_Transducer_distance(msg_);
  }

private:
  ::dvl_msgs::msg::Transducer msg_;
};

class Init_Transducer_id
{
public:
  Init_Transducer_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_Transducer_velocity id(::dvl_msgs::msg::Transducer::_id_type arg)
  {
    msg_.id = std::move(arg);
    return Init_Transducer_velocity(msg_);
  }

private:
  ::dvl_msgs::msg::Transducer msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::dvl_msgs::msg::Transducer>()
{
  return dvl_msgs::msg::builder::Init_Transducer_id();
}

}  // namespace dvl_msgs

#endif  // DVL_MSGS__MSG__DETAIL__TRANSDUCER__BUILDER_HPP_
