// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from dvl_msgs:msg/Transducer.idl
// generated code does not contain a copyright notice

#ifndef DVL_MSGS__MSG__DETAIL__TRANSDUCER__STRUCT_HPP_
#define DVL_MSGS__MSG__DETAIL__TRANSDUCER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__dvl_msgs__msg__Transducer __attribute__((deprecated))
#else
# define DEPRECATED__dvl_msgs__msg__Transducer __declspec(deprecated)
#endif

namespace dvl_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Transducer_
{
  using Type = Transducer_<ContainerAllocator>;

  explicit Transducer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0ll;
      this->velocity = 0.0;
      this->distance = 0.0;
      this->rssi = 0.0;
      this->nsd = 0.0;
    }
  }

  explicit Transducer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0ll;
      this->velocity = 0.0;
      this->distance = 0.0;
      this->rssi = 0.0;
      this->nsd = 0.0;
    }
  }

  // field types and members
  using _id_type =
    int64_t;
  _id_type id;
  using _velocity_type =
    double;
  _velocity_type velocity;
  using _distance_type =
    double;
  _distance_type distance;
  using _rssi_type =
    double;
  _rssi_type rssi;
  using _nsd_type =
    double;
  _nsd_type nsd;

  // setters for named parameter idiom
  Type & set__id(
    const int64_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__velocity(
    const double & _arg)
  {
    this->velocity = _arg;
    return *this;
  }
  Type & set__distance(
    const double & _arg)
  {
    this->distance = _arg;
    return *this;
  }
  Type & set__rssi(
    const double & _arg)
  {
    this->rssi = _arg;
    return *this;
  }
  Type & set__nsd(
    const double & _arg)
  {
    this->nsd = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    dvl_msgs::msg::Transducer_<ContainerAllocator> *;
  using ConstRawPtr =
    const dvl_msgs::msg::Transducer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dvl_msgs::msg::Transducer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dvl_msgs::msg::Transducer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dvl_msgs::msg::Transducer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dvl_msgs::msg::Transducer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dvl_msgs::msg::Transducer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dvl_msgs::msg::Transducer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dvl_msgs::msg::Transducer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dvl_msgs::msg::Transducer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__dvl_msgs__msg__Transducer
    std::shared_ptr<dvl_msgs::msg::Transducer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__dvl_msgs__msg__Transducer
    std::shared_ptr<dvl_msgs::msg::Transducer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Transducer_ & other) const
  {
    if (this->id != other.id) {
      return false;
    }
    if (this->velocity != other.velocity) {
      return false;
    }
    if (this->distance != other.distance) {
      return false;
    }
    if (this->rssi != other.rssi) {
      return false;
    }
    if (this->nsd != other.nsd) {
      return false;
    }
    return true;
  }
  bool operator!=(const Transducer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Transducer_

// alias to use template instance with default allocator
using Transducer =
  dvl_msgs::msg::Transducer_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace dvl_msgs

#endif  // DVL_MSGS__MSG__DETAIL__TRANSDUCER__STRUCT_HPP_
