// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from dvl_msgs:msg/Transducer.idl
// generated code does not contain a copyright notice

#ifndef DVL_MSGS__MSG__DETAIL__TRANSDUCER__TRAITS_HPP_
#define DVL_MSGS__MSG__DETAIL__TRANSDUCER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "dvl_msgs/msg/detail/transducer__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace dvl_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Transducer & msg,
  std::ostream & out)
{
  out << "{";
  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: velocity
  {
    out << "velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.velocity, out);
    out << ", ";
  }

  // member: distance
  {
    out << "distance: ";
    rosidl_generator_traits::value_to_yaml(msg.distance, out);
    out << ", ";
  }

  // member: rssi
  {
    out << "rssi: ";
    rosidl_generator_traits::value_to_yaml(msg.rssi, out);
    out << ", ";
  }

  // member: nsd
  {
    out << "nsd: ";
    rosidl_generator_traits::value_to_yaml(msg.nsd, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Transducer & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "velocity: ";
    rosidl_generator_traits::value_to_yaml(msg.velocity, out);
    out << "\n";
  }

  // member: distance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "distance: ";
    rosidl_generator_traits::value_to_yaml(msg.distance, out);
    out << "\n";
  }

  // member: rssi
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rssi: ";
    rosidl_generator_traits::value_to_yaml(msg.rssi, out);
    out << "\n";
  }

  // member: nsd
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "nsd: ";
    rosidl_generator_traits::value_to_yaml(msg.nsd, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Transducer & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace dvl_msgs

namespace rosidl_generator_traits
{

[[deprecated("use dvl_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const dvl_msgs::msg::Transducer & msg,
  std::ostream & out, size_t indentation = 0)
{
  dvl_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use dvl_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const dvl_msgs::msg::Transducer & msg)
{
  return dvl_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<dvl_msgs::msg::Transducer>()
{
  return "dvl_msgs::msg::Transducer";
}

template<>
inline const char * name<dvl_msgs::msg::Transducer>()
{
  return "dvl_msgs/msg/Transducer";
}

template<>
struct has_fixed_size<dvl_msgs::msg::Transducer>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<dvl_msgs::msg::Transducer>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<dvl_msgs::msg::Transducer>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // DVL_MSGS__MSG__DETAIL__TRANSDUCER__TRAITS_HPP_
