// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from dvl_msgs:msg/Velocity.idl
// generated code does not contain a copyright notice

#ifndef DVL_MSGS__MSG__DETAIL__VELOCITY__TRAITS_HPP_
#define DVL_MSGS__MSG__DETAIL__VELOCITY__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "dvl_msgs/msg/detail/velocity__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'velocity'
#include "geometry_msgs/msg/detail/vector3__traits.hpp"

namespace dvl_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Velocity & msg,
  std::ostream & out)
{
  out << "{";
  // member: time_ms
  {
    out << "time_ms: ";
    rosidl_generator_traits::value_to_yaml(msg.time_ms, out);
    out << ", ";
  }

  // member: valid
  {
    out << "valid: ";
    rosidl_generator_traits::value_to_yaml(msg.valid, out);
    out << ", ";
  }

  // member: velocity
  {
    out << "velocity: ";
    to_flow_style_yaml(msg.velocity, out);
    out << ", ";
  }

  // member: figure_of_merit
  {
    out << "figure_of_merit: ";
    rosidl_generator_traits::value_to_yaml(msg.figure_of_merit, out);
    out << ", ";
  }

  // member: covariance
  {
    if (msg.covariance.size() == 0) {
      out << "covariance: []";
    } else {
      out << "covariance: [";
      size_t pending_items = msg.covariance.size();
      for (auto item : msg.covariance) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: altitude
  {
    out << "altitude: ";
    rosidl_generator_traits::value_to_yaml(msg.altitude, out);
    out << ", ";
  }

  // member: time_of_validity
  {
    out << "time_of_validity: ";
    rosidl_generator_traits::value_to_yaml(msg.time_of_validity, out);
    out << ", ";
  }

  // member: time_of_transmission
  {
    out << "time_of_transmission: ";
    rosidl_generator_traits::value_to_yaml(msg.time_of_transmission, out);
    out << ", ";
  }

  // member: status
  {
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Velocity & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: time_ms
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time_ms: ";
    rosidl_generator_traits::value_to_yaml(msg.time_ms, out);
    out << "\n";
  }

  // member: valid
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "valid: ";
    rosidl_generator_traits::value_to_yaml(msg.valid, out);
    out << "\n";
  }

  // member: velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "velocity:\n";
    to_block_style_yaml(msg.velocity, out, indentation + 2);
  }

  // member: figure_of_merit
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "figure_of_merit: ";
    rosidl_generator_traits::value_to_yaml(msg.figure_of_merit, out);
    out << "\n";
  }

  // member: covariance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.covariance.size() == 0) {
      out << "covariance: []\n";
    } else {
      out << "covariance:\n";
      for (auto item : msg.covariance) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: altitude
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "altitude: ";
    rosidl_generator_traits::value_to_yaml(msg.altitude, out);
    out << "\n";
  }

  // member: time_of_validity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time_of_validity: ";
    rosidl_generator_traits::value_to_yaml(msg.time_of_validity, out);
    out << "\n";
  }

  // member: time_of_transmission
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time_of_transmission: ";
    rosidl_generator_traits::value_to_yaml(msg.time_of_transmission, out);
    out << "\n";
  }

  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Velocity & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace dvl_msgs

namespace rosidl_generator_traits
{

[[deprecated("use dvl_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const dvl_msgs::msg::Velocity & msg,
  std::ostream & out, size_t indentation = 0)
{
  dvl_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use dvl_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const dvl_msgs::msg::Velocity & msg)
{
  return dvl_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<dvl_msgs::msg::Velocity>()
{
  return "dvl_msgs::msg::Velocity";
}

template<>
inline const char * name<dvl_msgs::msg::Velocity>()
{
  return "dvl_msgs/msg/Velocity";
}

template<>
struct has_fixed_size<dvl_msgs::msg::Velocity>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::Vector3>::value> {};

template<>
struct has_bounded_size<dvl_msgs::msg::Velocity>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::Vector3>::value> {};

template<>
struct is_message<dvl_msgs::msg::Velocity>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // DVL_MSGS__MSG__DETAIL__VELOCITY__TRAITS_HPP_
