// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from dvl_msgs:msg/VelocityTransducerReport.idl
// generated code does not contain a copyright notice
#include "dvl_msgs/msg/detail/velocity_transducer_report__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `transducers`
#include "dvl_msgs/msg/detail/transducer__functions.h"
// Member `velocity`
#include "dvl_msgs/msg/detail/velocity__functions.h"

bool
dvl_msgs__msg__VelocityTransducerReport__init(dvl_msgs__msg__VelocityTransducerReport * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    dvl_msgs__msg__VelocityTransducerReport__fini(msg);
    return false;
  }
  // transducers
  if (!dvl_msgs__msg__Transducer__Sequence__init(&msg->transducers, 0)) {
    dvl_msgs__msg__VelocityTransducerReport__fini(msg);
    return false;
  }
  // velocity
  if (!dvl_msgs__msg__Velocity__init(&msg->velocity)) {
    dvl_msgs__msg__VelocityTransducerReport__fini(msg);
    return false;
  }
  return true;
}

void
dvl_msgs__msg__VelocityTransducerReport__fini(dvl_msgs__msg__VelocityTransducerReport * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // transducers
  dvl_msgs__msg__Transducer__Sequence__fini(&msg->transducers);
  // velocity
  dvl_msgs__msg__Velocity__fini(&msg->velocity);
}

bool
dvl_msgs__msg__VelocityTransducerReport__are_equal(const dvl_msgs__msg__VelocityTransducerReport * lhs, const dvl_msgs__msg__VelocityTransducerReport * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // transducers
  if (!dvl_msgs__msg__Transducer__Sequence__are_equal(
      &(lhs->transducers), &(rhs->transducers)))
  {
    return false;
  }
  // velocity
  if (!dvl_msgs__msg__Velocity__are_equal(
      &(lhs->velocity), &(rhs->velocity)))
  {
    return false;
  }
  return true;
}

bool
dvl_msgs__msg__VelocityTransducerReport__copy(
  const dvl_msgs__msg__VelocityTransducerReport * input,
  dvl_msgs__msg__VelocityTransducerReport * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // transducers
  if (!dvl_msgs__msg__Transducer__Sequence__copy(
      &(input->transducers), &(output->transducers)))
  {
    return false;
  }
  // velocity
  if (!dvl_msgs__msg__Velocity__copy(
      &(input->velocity), &(output->velocity)))
  {
    return false;
  }
  return true;
}

dvl_msgs__msg__VelocityTransducerReport *
dvl_msgs__msg__VelocityTransducerReport__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dvl_msgs__msg__VelocityTransducerReport * msg = (dvl_msgs__msg__VelocityTransducerReport *)allocator.allocate(sizeof(dvl_msgs__msg__VelocityTransducerReport), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(dvl_msgs__msg__VelocityTransducerReport));
  bool success = dvl_msgs__msg__VelocityTransducerReport__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
dvl_msgs__msg__VelocityTransducerReport__destroy(dvl_msgs__msg__VelocityTransducerReport * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    dvl_msgs__msg__VelocityTransducerReport__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
dvl_msgs__msg__VelocityTransducerReport__Sequence__init(dvl_msgs__msg__VelocityTransducerReport__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dvl_msgs__msg__VelocityTransducerReport * data = NULL;

  if (size) {
    data = (dvl_msgs__msg__VelocityTransducerReport *)allocator.zero_allocate(size, sizeof(dvl_msgs__msg__VelocityTransducerReport), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = dvl_msgs__msg__VelocityTransducerReport__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        dvl_msgs__msg__VelocityTransducerReport__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
dvl_msgs__msg__VelocityTransducerReport__Sequence__fini(dvl_msgs__msg__VelocityTransducerReport__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      dvl_msgs__msg__VelocityTransducerReport__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

dvl_msgs__msg__VelocityTransducerReport__Sequence *
dvl_msgs__msg__VelocityTransducerReport__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dvl_msgs__msg__VelocityTransducerReport__Sequence * array = (dvl_msgs__msg__VelocityTransducerReport__Sequence *)allocator.allocate(sizeof(dvl_msgs__msg__VelocityTransducerReport__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = dvl_msgs__msg__VelocityTransducerReport__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
dvl_msgs__msg__VelocityTransducerReport__Sequence__destroy(dvl_msgs__msg__VelocityTransducerReport__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    dvl_msgs__msg__VelocityTransducerReport__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
dvl_msgs__msg__VelocityTransducerReport__Sequence__are_equal(const dvl_msgs__msg__VelocityTransducerReport__Sequence * lhs, const dvl_msgs__msg__VelocityTransducerReport__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!dvl_msgs__msg__VelocityTransducerReport__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
dvl_msgs__msg__VelocityTransducerReport__Sequence__copy(
  const dvl_msgs__msg__VelocityTransducerReport__Sequence * input,
  dvl_msgs__msg__VelocityTransducerReport__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(dvl_msgs__msg__VelocityTransducerReport);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    dvl_msgs__msg__VelocityTransducerReport * data =
      (dvl_msgs__msg__VelocityTransducerReport *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!dvl_msgs__msg__VelocityTransducerReport__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          dvl_msgs__msg__VelocityTransducerReport__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!dvl_msgs__msg__VelocityTransducerReport__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
