// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from dvl_msgs:msg/VelocityTransducerReport.idl
// generated code does not contain a copyright notice

#ifndef DVL_MSGS__MSG__DETAIL__VELOCITY_TRANSDUCER_REPORT__TRAITS_HPP_
#define DVL_MSGS__MSG__DETAIL__VELOCITY_TRANSDUCER_REPORT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "dvl_msgs/msg/detail/velocity_transducer_report__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'transducers'
#include "dvl_msgs/msg/detail/transducer__traits.hpp"
// Member 'velocity'
#include "dvl_msgs/msg/detail/velocity__traits.hpp"

namespace dvl_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const VelocityTransducerReport & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: transducers
  {
    if (msg.transducers.size() == 0) {
      out << "transducers: []";
    } else {
      out << "transducers: [";
      size_t pending_items = msg.transducers.size();
      for (auto item : msg.transducers) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: velocity
  {
    out << "velocity: ";
    to_flow_style_yaml(msg.velocity, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const VelocityTransducerReport & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: transducers
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.transducers.size() == 0) {
      out << "transducers: []\n";
    } else {
      out << "transducers:\n";
      for (auto item : msg.transducers) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "velocity:\n";
    to_block_style_yaml(msg.velocity, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const VelocityTransducerReport & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace dvl_msgs

namespace rosidl_generator_traits
{

[[deprecated("use dvl_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const dvl_msgs::msg::VelocityTransducerReport & msg,
  std::ostream & out, size_t indentation = 0)
{
  dvl_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use dvl_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const dvl_msgs::msg::VelocityTransducerReport & msg)
{
  return dvl_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<dvl_msgs::msg::VelocityTransducerReport>()
{
  return "dvl_msgs::msg::VelocityTransducerReport";
}

template<>
inline const char * name<dvl_msgs::msg::VelocityTransducerReport>()
{
  return "dvl_msgs/msg/VelocityTransducerReport";
}

template<>
struct has_fixed_size<dvl_msgs::msg::VelocityTransducerReport>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<dvl_msgs::msg::VelocityTransducerReport>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<dvl_msgs::msg::VelocityTransducerReport>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // DVL_MSGS__MSG__DETAIL__VELOCITY_TRANSDUCER_REPORT__TRAITS_HPP_
