// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from dvl_msgs:msg/ConfigResult.idl
// generated code does not contain a copyright notice
#include "dvl_msgs/msg/detail/config_result__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `range_mode`
#include "rosidl_runtime_c/string_functions.h"

bool
dvl_msgs__msg__ConfigResult__init(dvl_msgs__msg__ConfigResult * msg)
{
  if (!msg) {
    return false;
  }
  // speed_of_sound
  // acoustic_enabled
  // dark_mode_enabled
  // mounting_rotation_offset
  // range_mode
  if (!rosidl_runtime_c__String__init(&msg->range_mode)) {
    dvl_msgs__msg__ConfigResult__fini(msg);
    return false;
  }
  // periodic_cyling_enabled
  return true;
}

void
dvl_msgs__msg__ConfigResult__fini(dvl_msgs__msg__ConfigResult * msg)
{
  if (!msg) {
    return;
  }
  // speed_of_sound
  // acoustic_enabled
  // dark_mode_enabled
  // mounting_rotation_offset
  // range_mode
  rosidl_runtime_c__String__fini(&msg->range_mode);
  // periodic_cyling_enabled
}

bool
dvl_msgs__msg__ConfigResult__are_equal(const dvl_msgs__msg__ConfigResult * lhs, const dvl_msgs__msg__ConfigResult * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // speed_of_sound
  if (lhs->speed_of_sound != rhs->speed_of_sound) {
    return false;
  }
  // acoustic_enabled
  if (lhs->acoustic_enabled != rhs->acoustic_enabled) {
    return false;
  }
  // dark_mode_enabled
  if (lhs->dark_mode_enabled != rhs->dark_mode_enabled) {
    return false;
  }
  // mounting_rotation_offset
  if (lhs->mounting_rotation_offset != rhs->mounting_rotation_offset) {
    return false;
  }
  // range_mode
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->range_mode), &(rhs->range_mode)))
  {
    return false;
  }
  // periodic_cyling_enabled
  if (lhs->periodic_cyling_enabled != rhs->periodic_cyling_enabled) {
    return false;
  }
  return true;
}

bool
dvl_msgs__msg__ConfigResult__copy(
  const dvl_msgs__msg__ConfigResult * input,
  dvl_msgs__msg__ConfigResult * output)
{
  if (!input || !output) {
    return false;
  }
  // speed_of_sound
  output->speed_of_sound = input->speed_of_sound;
  // acoustic_enabled
  output->acoustic_enabled = input->acoustic_enabled;
  // dark_mode_enabled
  output->dark_mode_enabled = input->dark_mode_enabled;
  // mounting_rotation_offset
  output->mounting_rotation_offset = input->mounting_rotation_offset;
  // range_mode
  if (!rosidl_runtime_c__String__copy(
      &(input->range_mode), &(output->range_mode)))
  {
    return false;
  }
  // periodic_cyling_enabled
  output->periodic_cyling_enabled = input->periodic_cyling_enabled;
  return true;
}

dvl_msgs__msg__ConfigResult *
dvl_msgs__msg__ConfigResult__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dvl_msgs__msg__ConfigResult * msg = (dvl_msgs__msg__ConfigResult *)allocator.allocate(sizeof(dvl_msgs__msg__ConfigResult), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(dvl_msgs__msg__ConfigResult));
  bool success = dvl_msgs__msg__ConfigResult__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
dvl_msgs__msg__ConfigResult__destroy(dvl_msgs__msg__ConfigResult * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    dvl_msgs__msg__ConfigResult__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
dvl_msgs__msg__ConfigResult__Sequence__init(dvl_msgs__msg__ConfigResult__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dvl_msgs__msg__ConfigResult * data = NULL;

  if (size) {
    data = (dvl_msgs__msg__ConfigResult *)allocator.zero_allocate(size, sizeof(dvl_msgs__msg__ConfigResult), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = dvl_msgs__msg__ConfigResult__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        dvl_msgs__msg__ConfigResult__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
dvl_msgs__msg__ConfigResult__Sequence__fini(dvl_msgs__msg__ConfigResult__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      dvl_msgs__msg__ConfigResult__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

dvl_msgs__msg__ConfigResult__Sequence *
dvl_msgs__msg__ConfigResult__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dvl_msgs__msg__ConfigResult__Sequence * array = (dvl_msgs__msg__ConfigResult__Sequence *)allocator.allocate(sizeof(dvl_msgs__msg__ConfigResult__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = dvl_msgs__msg__ConfigResult__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
dvl_msgs__msg__ConfigResult__Sequence__destroy(dvl_msgs__msg__ConfigResult__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    dvl_msgs__msg__ConfigResult__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
dvl_msgs__msg__ConfigResult__Sequence__are_equal(const dvl_msgs__msg__ConfigResult__Sequence * lhs, const dvl_msgs__msg__ConfigResult__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!dvl_msgs__msg__ConfigResult__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
dvl_msgs__msg__ConfigResult__Sequence__copy(
  const dvl_msgs__msg__ConfigResult__Sequence * input,
  dvl_msgs__msg__ConfigResult__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(dvl_msgs__msg__ConfigResult);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    dvl_msgs__msg__ConfigResult * data =
      (dvl_msgs__msg__ConfigResult *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!dvl_msgs__msg__ConfigResult__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          dvl_msgs__msg__ConfigResult__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!dvl_msgs__msg__ConfigResult__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
