// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from dvl_msgs:msg/ConfigResult.idl
// generated code does not contain a copyright notice

#ifndef DVL_MSGS__MSG__DETAIL__CONFIG_RESULT__STRUCT_HPP_
#define DVL_MSGS__MSG__DETAIL__CONFIG_RESULT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__dvl_msgs__msg__ConfigResult __attribute__((deprecated))
#else
# define DEPRECATED__dvl_msgs__msg__ConfigResult __declspec(deprecated)
#endif

namespace dvl_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ConfigResult_
{
  using Type = ConfigResult_<ContainerAllocator>;

  explicit ConfigResult_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->speed_of_sound = 0.0;
      this->acoustic_enabled = false;
      this->dark_mode_enabled = false;
      this->mounting_rotation_offset = 0.0;
      this->range_mode = "";
      this->periodic_cyling_enabled = false;
    }
  }

  explicit ConfigResult_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : range_mode(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->speed_of_sound = 0.0;
      this->acoustic_enabled = false;
      this->dark_mode_enabled = false;
      this->mounting_rotation_offset = 0.0;
      this->range_mode = "";
      this->periodic_cyling_enabled = false;
    }
  }

  // field types and members
  using _speed_of_sound_type =
    double;
  _speed_of_sound_type speed_of_sound;
  using _acoustic_enabled_type =
    bool;
  _acoustic_enabled_type acoustic_enabled;
  using _dark_mode_enabled_type =
    bool;
  _dark_mode_enabled_type dark_mode_enabled;
  using _mounting_rotation_offset_type =
    double;
  _mounting_rotation_offset_type mounting_rotation_offset;
  using _range_mode_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _range_mode_type range_mode;
  using _periodic_cyling_enabled_type =
    bool;
  _periodic_cyling_enabled_type periodic_cyling_enabled;

  // setters for named parameter idiom
  Type & set__speed_of_sound(
    const double & _arg)
  {
    this->speed_of_sound = _arg;
    return *this;
  }
  Type & set__acoustic_enabled(
    const bool & _arg)
  {
    this->acoustic_enabled = _arg;
    return *this;
  }
  Type & set__dark_mode_enabled(
    const bool & _arg)
  {
    this->dark_mode_enabled = _arg;
    return *this;
  }
  Type & set__mounting_rotation_offset(
    const double & _arg)
  {
    this->mounting_rotation_offset = _arg;
    return *this;
  }
  Type & set__range_mode(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->range_mode = _arg;
    return *this;
  }
  Type & set__periodic_cyling_enabled(
    const bool & _arg)
  {
    this->periodic_cyling_enabled = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    dvl_msgs::msg::ConfigResult_<ContainerAllocator> *;
  using ConstRawPtr =
    const dvl_msgs::msg::ConfigResult_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dvl_msgs::msg::ConfigResult_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dvl_msgs::msg::ConfigResult_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dvl_msgs::msg::ConfigResult_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dvl_msgs::msg::ConfigResult_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dvl_msgs::msg::ConfigResult_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dvl_msgs::msg::ConfigResult_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dvl_msgs::msg::ConfigResult_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dvl_msgs::msg::ConfigResult_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__dvl_msgs__msg__ConfigResult
    std::shared_ptr<dvl_msgs::msg::ConfigResult_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__dvl_msgs__msg__ConfigResult
    std::shared_ptr<dvl_msgs::msg::ConfigResult_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ConfigResult_ & other) const
  {
    if (this->speed_of_sound != other.speed_of_sound) {
      return false;
    }
    if (this->acoustic_enabled != other.acoustic_enabled) {
      return false;
    }
    if (this->dark_mode_enabled != other.dark_mode_enabled) {
      return false;
    }
    if (this->mounting_rotation_offset != other.mounting_rotation_offset) {
      return false;
    }
    if (this->range_mode != other.range_mode) {
      return false;
    }
    if (this->periodic_cyling_enabled != other.periodic_cyling_enabled) {
      return false;
    }
    return true;
  }
  bool operator!=(const ConfigResult_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ConfigResult_

// alias to use template instance with default allocator
using ConfigResult =
  dvl_msgs::msg::ConfigResult_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace dvl_msgs

#endif  // DVL_MSGS__MSG__DETAIL__CONFIG_RESULT__STRUCT_HPP_
