// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from dvl_msgs:msg/ConfigResult.idl
// generated code does not contain a copyright notice

#ifndef DVL_MSGS__MSG__DETAIL__CONFIG_RESULT__TRAITS_HPP_
#define DVL_MSGS__MSG__DETAIL__CONFIG_RESULT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "dvl_msgs/msg/detail/config_result__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace dvl_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ConfigResult & msg,
  std::ostream & out)
{
  out << "{";
  // member: speed_of_sound
  {
    out << "speed_of_sound: ";
    rosidl_generator_traits::value_to_yaml(msg.speed_of_sound, out);
    out << ", ";
  }

  // member: acoustic_enabled
  {
    out << "acoustic_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.acoustic_enabled, out);
    out << ", ";
  }

  // member: dark_mode_enabled
  {
    out << "dark_mode_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.dark_mode_enabled, out);
    out << ", ";
  }

  // member: mounting_rotation_offset
  {
    out << "mounting_rotation_offset: ";
    rosidl_generator_traits::value_to_yaml(msg.mounting_rotation_offset, out);
    out << ", ";
  }

  // member: range_mode
  {
    out << "range_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.range_mode, out);
    out << ", ";
  }

  // member: periodic_cyling_enabled
  {
    out << "periodic_cyling_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.periodic_cyling_enabled, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ConfigResult & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: speed_of_sound
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "speed_of_sound: ";
    rosidl_generator_traits::value_to_yaml(msg.speed_of_sound, out);
    out << "\n";
  }

  // member: acoustic_enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "acoustic_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.acoustic_enabled, out);
    out << "\n";
  }

  // member: dark_mode_enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dark_mode_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.dark_mode_enabled, out);
    out << "\n";
  }

  // member: mounting_rotation_offset
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "mounting_rotation_offset: ";
    rosidl_generator_traits::value_to_yaml(msg.mounting_rotation_offset, out);
    out << "\n";
  }

  // member: range_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "range_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.range_mode, out);
    out << "\n";
  }

  // member: periodic_cyling_enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "periodic_cyling_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.periodic_cyling_enabled, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ConfigResult & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace dvl_msgs

namespace rosidl_generator_traits
{

[[deprecated("use dvl_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const dvl_msgs::msg::ConfigResult & msg,
  std::ostream & out, size_t indentation = 0)
{
  dvl_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use dvl_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const dvl_msgs::msg::ConfigResult & msg)
{
  return dvl_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<dvl_msgs::msg::ConfigResult>()
{
  return "dvl_msgs::msg::ConfigResult";
}

template<>
inline const char * name<dvl_msgs::msg::ConfigResult>()
{
  return "dvl_msgs/msg/ConfigResult";
}

template<>
struct has_fixed_size<dvl_msgs::msg::ConfigResult>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<dvl_msgs::msg::ConfigResult>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<dvl_msgs::msg::ConfigResult>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // DVL_MSGS__MSG__DETAIL__CONFIG_RESULT__TRAITS_HPP_
