// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from dvl_msgs:msg/DeadReckoning.idl
// generated code does not contain a copyright notice
#include "dvl_msgs/msg/detail/dead_reckoning__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `distance`
// Member `rpy`
#include "geometry_msgs/msg/detail/vector3__functions.h"

bool
dvl_msgs__msg__DeadReckoning__init(dvl_msgs__msg__DeadReckoning * msg)
{
  if (!msg) {
    return false;
  }
  // time_stamp
  // distance
  if (!geometry_msgs__msg__Vector3__init(&msg->distance)) {
    dvl_msgs__msg__DeadReckoning__fini(msg);
    return false;
  }
  // stddev
  // rpy
  if (!geometry_msgs__msg__Vector3__init(&msg->rpy)) {
    dvl_msgs__msg__DeadReckoning__fini(msg);
    return false;
  }
  // status
  return true;
}

void
dvl_msgs__msg__DeadReckoning__fini(dvl_msgs__msg__DeadReckoning * msg)
{
  if (!msg) {
    return;
  }
  // time_stamp
  // distance
  geometry_msgs__msg__Vector3__fini(&msg->distance);
  // stddev
  // rpy
  geometry_msgs__msg__Vector3__fini(&msg->rpy);
  // status
}

bool
dvl_msgs__msg__DeadReckoning__are_equal(const dvl_msgs__msg__DeadReckoning * lhs, const dvl_msgs__msg__DeadReckoning * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // time_stamp
  if (lhs->time_stamp != rhs->time_stamp) {
    return false;
  }
  // distance
  if (!geometry_msgs__msg__Vector3__are_equal(
      &(lhs->distance), &(rhs->distance)))
  {
    return false;
  }
  // stddev
  if (lhs->stddev != rhs->stddev) {
    return false;
  }
  // rpy
  if (!geometry_msgs__msg__Vector3__are_equal(
      &(lhs->rpy), &(rhs->rpy)))
  {
    return false;
  }
  // status
  if (lhs->status != rhs->status) {
    return false;
  }
  return true;
}

bool
dvl_msgs__msg__DeadReckoning__copy(
  const dvl_msgs__msg__DeadReckoning * input,
  dvl_msgs__msg__DeadReckoning * output)
{
  if (!input || !output) {
    return false;
  }
  // time_stamp
  output->time_stamp = input->time_stamp;
  // distance
  if (!geometry_msgs__msg__Vector3__copy(
      &(input->distance), &(output->distance)))
  {
    return false;
  }
  // stddev
  output->stddev = input->stddev;
  // rpy
  if (!geometry_msgs__msg__Vector3__copy(
      &(input->rpy), &(output->rpy)))
  {
    return false;
  }
  // status
  output->status = input->status;
  return true;
}

dvl_msgs__msg__DeadReckoning *
dvl_msgs__msg__DeadReckoning__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dvl_msgs__msg__DeadReckoning * msg = (dvl_msgs__msg__DeadReckoning *)allocator.allocate(sizeof(dvl_msgs__msg__DeadReckoning), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(dvl_msgs__msg__DeadReckoning));
  bool success = dvl_msgs__msg__DeadReckoning__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
dvl_msgs__msg__DeadReckoning__destroy(dvl_msgs__msg__DeadReckoning * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    dvl_msgs__msg__DeadReckoning__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
dvl_msgs__msg__DeadReckoning__Sequence__init(dvl_msgs__msg__DeadReckoning__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dvl_msgs__msg__DeadReckoning * data = NULL;

  if (size) {
    data = (dvl_msgs__msg__DeadReckoning *)allocator.zero_allocate(size, sizeof(dvl_msgs__msg__DeadReckoning), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = dvl_msgs__msg__DeadReckoning__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        dvl_msgs__msg__DeadReckoning__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
dvl_msgs__msg__DeadReckoning__Sequence__fini(dvl_msgs__msg__DeadReckoning__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      dvl_msgs__msg__DeadReckoning__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

dvl_msgs__msg__DeadReckoning__Sequence *
dvl_msgs__msg__DeadReckoning__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dvl_msgs__msg__DeadReckoning__Sequence * array = (dvl_msgs__msg__DeadReckoning__Sequence *)allocator.allocate(sizeof(dvl_msgs__msg__DeadReckoning__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = dvl_msgs__msg__DeadReckoning__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
dvl_msgs__msg__DeadReckoning__Sequence__destroy(dvl_msgs__msg__DeadReckoning__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    dvl_msgs__msg__DeadReckoning__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
dvl_msgs__msg__DeadReckoning__Sequence__are_equal(const dvl_msgs__msg__DeadReckoning__Sequence * lhs, const dvl_msgs__msg__DeadReckoning__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!dvl_msgs__msg__DeadReckoning__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
dvl_msgs__msg__DeadReckoning__Sequence__copy(
  const dvl_msgs__msg__DeadReckoning__Sequence * input,
  dvl_msgs__msg__DeadReckoning__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(dvl_msgs__msg__DeadReckoning);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    dvl_msgs__msg__DeadReckoning * data =
      (dvl_msgs__msg__DeadReckoning *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!dvl_msgs__msg__DeadReckoning__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          dvl_msgs__msg__DeadReckoning__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!dvl_msgs__msg__DeadReckoning__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
