// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from dvl_msgs:msg/DeadReckoning.idl
// generated code does not contain a copyright notice

#ifndef DVL_MSGS__MSG__DETAIL__DEAD_RECKONING__STRUCT_HPP_
#define DVL_MSGS__MSG__DETAIL__DEAD_RECKONING__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'distance'
// Member 'rpy'
#include "geometry_msgs/msg/detail/vector3__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__dvl_msgs__msg__DeadReckoning __attribute__((deprecated))
#else
# define DEPRECATED__dvl_msgs__msg__DeadReckoning __declspec(deprecated)
#endif

namespace dvl_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DeadReckoning_
{
  using Type = DeadReckoning_<ContainerAllocator>;

  explicit DeadReckoning_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : distance(_init),
    rpy(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->time_stamp = 0.0;
      this->stddev = 0.0;
      this->status = 0;
    }
  }

  explicit DeadReckoning_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : distance(_alloc, _init),
    rpy(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->time_stamp = 0.0;
      this->stddev = 0.0;
      this->status = 0;
    }
  }

  // field types and members
  using _time_stamp_type =
    double;
  _time_stamp_type time_stamp;
  using _distance_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _distance_type distance;
  using _stddev_type =
    double;
  _stddev_type stddev;
  using _rpy_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _rpy_type rpy;
  using _status_type =
    uint8_t;
  _status_type status;

  // setters for named parameter idiom
  Type & set__time_stamp(
    const double & _arg)
  {
    this->time_stamp = _arg;
    return *this;
  }
  Type & set__distance(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->distance = _arg;
    return *this;
  }
  Type & set__stddev(
    const double & _arg)
  {
    this->stddev = _arg;
    return *this;
  }
  Type & set__rpy(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->rpy = _arg;
    return *this;
  }
  Type & set__status(
    const uint8_t & _arg)
  {
    this->status = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    dvl_msgs::msg::DeadReckoning_<ContainerAllocator> *;
  using ConstRawPtr =
    const dvl_msgs::msg::DeadReckoning_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dvl_msgs::msg::DeadReckoning_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dvl_msgs::msg::DeadReckoning_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dvl_msgs::msg::DeadReckoning_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dvl_msgs::msg::DeadReckoning_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dvl_msgs::msg::DeadReckoning_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dvl_msgs::msg::DeadReckoning_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dvl_msgs::msg::DeadReckoning_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dvl_msgs::msg::DeadReckoning_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__dvl_msgs__msg__DeadReckoning
    std::shared_ptr<dvl_msgs::msg::DeadReckoning_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__dvl_msgs__msg__DeadReckoning
    std::shared_ptr<dvl_msgs::msg::DeadReckoning_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DeadReckoning_ & other) const
  {
    if (this->time_stamp != other.time_stamp) {
      return false;
    }
    if (this->distance != other.distance) {
      return false;
    }
    if (this->stddev != other.stddev) {
      return false;
    }
    if (this->rpy != other.rpy) {
      return false;
    }
    if (this->status != other.status) {
      return false;
    }
    return true;
  }
  bool operator!=(const DeadReckoning_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DeadReckoning_

// alias to use template instance with default allocator
using DeadReckoning =
  dvl_msgs::msg::DeadReckoning_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace dvl_msgs

#endif  // DVL_MSGS__MSG__DETAIL__DEAD_RECKONING__STRUCT_HPP_
