// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from dvl_msgs:msg/DeadReckoningReport.idl
// generated code does not contain a copyright notice

#ifndef DVL_MSGS__MSG__DETAIL__DEAD_RECKONING_REPORT__FUNCTIONS_H_
#define DVL_MSGS__MSG__DETAIL__DEAD_RECKONING_REPORT__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/action_type_support_struct.h"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_runtime_c/service_type_support_struct.h"
#include "rosidl_runtime_c/type_description/type_description__struct.h"
#include "rosidl_runtime_c/type_description/type_source__struct.h"
#include "rosidl_runtime_c/type_hash.h"
#include "rosidl_runtime_c/visibility_control.h"
#include "dvl_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "dvl_msgs/msg/detail/dead_reckoning_report__struct.h"

/// Initialize msg/DeadReckoningReport message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * dvl_msgs__msg__DeadReckoningReport
 * )) before or use
 * dvl_msgs__msg__DeadReckoningReport__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_dvl_msgs
bool
dvl_msgs__msg__DeadReckoningReport__init(dvl_msgs__msg__DeadReckoningReport * msg);

/// Finalize msg/DeadReckoningReport message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_dvl_msgs
void
dvl_msgs__msg__DeadReckoningReport__fini(dvl_msgs__msg__DeadReckoningReport * msg);

/// Create msg/DeadReckoningReport message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * dvl_msgs__msg__DeadReckoningReport__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_dvl_msgs
dvl_msgs__msg__DeadReckoningReport *
dvl_msgs__msg__DeadReckoningReport__create();

/// Destroy msg/DeadReckoningReport message.
/**
 * It calls
 * dvl_msgs__msg__DeadReckoningReport__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_dvl_msgs
void
dvl_msgs__msg__DeadReckoningReport__destroy(dvl_msgs__msg__DeadReckoningReport * msg);

/// Check for msg/DeadReckoningReport message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_dvl_msgs
bool
dvl_msgs__msg__DeadReckoningReport__are_equal(const dvl_msgs__msg__DeadReckoningReport * lhs, const dvl_msgs__msg__DeadReckoningReport * rhs);

/// Copy a msg/DeadReckoningReport message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_dvl_msgs
bool
dvl_msgs__msg__DeadReckoningReport__copy(
  const dvl_msgs__msg__DeadReckoningReport * input,
  dvl_msgs__msg__DeadReckoningReport * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_dvl_msgs
const rosidl_type_hash_t *
dvl_msgs__msg__DeadReckoningReport__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_dvl_msgs
const rosidl_runtime_c__type_description__TypeDescription *
dvl_msgs__msg__DeadReckoningReport__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_dvl_msgs
const rosidl_runtime_c__type_description__TypeSource *
dvl_msgs__msg__DeadReckoningReport__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_dvl_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
dvl_msgs__msg__DeadReckoningReport__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of msg/DeadReckoningReport messages.
/**
 * It allocates the memory for the number of elements and calls
 * dvl_msgs__msg__DeadReckoningReport__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_dvl_msgs
bool
dvl_msgs__msg__DeadReckoningReport__Sequence__init(dvl_msgs__msg__DeadReckoningReport__Sequence * array, size_t size);

/// Finalize array of msg/DeadReckoningReport messages.
/**
 * It calls
 * dvl_msgs__msg__DeadReckoningReport__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_dvl_msgs
void
dvl_msgs__msg__DeadReckoningReport__Sequence__fini(dvl_msgs__msg__DeadReckoningReport__Sequence * array);

/// Create array of msg/DeadReckoningReport messages.
/**
 * It allocates the memory for the array and calls
 * dvl_msgs__msg__DeadReckoningReport__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_dvl_msgs
dvl_msgs__msg__DeadReckoningReport__Sequence *
dvl_msgs__msg__DeadReckoningReport__Sequence__create(size_t size);

/// Destroy array of msg/DeadReckoningReport messages.
/**
 * It calls
 * dvl_msgs__msg__DeadReckoningReport__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_dvl_msgs
void
dvl_msgs__msg__DeadReckoningReport__Sequence__destroy(dvl_msgs__msg__DeadReckoningReport__Sequence * array);

/// Check for msg/DeadReckoningReport message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_dvl_msgs
bool
dvl_msgs__msg__DeadReckoningReport__Sequence__are_equal(const dvl_msgs__msg__DeadReckoningReport__Sequence * lhs, const dvl_msgs__msg__DeadReckoningReport__Sequence * rhs);

/// Copy an array of msg/DeadReckoningReport messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_dvl_msgs
bool
dvl_msgs__msg__DeadReckoningReport__Sequence__copy(
  const dvl_msgs__msg__DeadReckoningReport__Sequence * input,
  dvl_msgs__msg__DeadReckoningReport__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // DVL_MSGS__MSG__DETAIL__DEAD_RECKONING_REPORT__FUNCTIONS_H_
