// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from dvl_msgs:msg/DeadReckoningReport.idl
// generated code does not contain a copyright notice

#ifndef DVL_MSGS__MSG__DETAIL__DEAD_RECKONING_REPORT__STRUCT_HPP_
#define DVL_MSGS__MSG__DETAIL__DEAD_RECKONING_REPORT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'report'
#include "dvl_msgs/msg/detail/dead_reckoning__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__dvl_msgs__msg__DeadReckoningReport __attribute__((deprecated))
#else
# define DEPRECATED__dvl_msgs__msg__DeadReckoningReport __declspec(deprecated)
#endif

namespace dvl_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DeadReckoningReport_
{
  using Type = DeadReckoningReport_<ContainerAllocator>;

  explicit DeadReckoningReport_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    report(_init)
  {
    (void)_init;
  }

  explicit DeadReckoningReport_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    report(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _report_type =
    dvl_msgs::msg::DeadReckoning_<ContainerAllocator>;
  _report_type report;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__report(
    const dvl_msgs::msg::DeadReckoning_<ContainerAllocator> & _arg)
  {
    this->report = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    dvl_msgs::msg::DeadReckoningReport_<ContainerAllocator> *;
  using ConstRawPtr =
    const dvl_msgs::msg::DeadReckoningReport_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dvl_msgs::msg::DeadReckoningReport_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dvl_msgs::msg::DeadReckoningReport_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dvl_msgs::msg::DeadReckoningReport_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dvl_msgs::msg::DeadReckoningReport_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dvl_msgs::msg::DeadReckoningReport_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dvl_msgs::msg::DeadReckoningReport_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dvl_msgs::msg::DeadReckoningReport_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dvl_msgs::msg::DeadReckoningReport_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__dvl_msgs__msg__DeadReckoningReport
    std::shared_ptr<dvl_msgs::msg::DeadReckoningReport_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__dvl_msgs__msg__DeadReckoningReport
    std::shared_ptr<dvl_msgs::msg::DeadReckoningReport_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DeadReckoningReport_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->report != other.report) {
      return false;
    }
    return true;
  }
  bool operator!=(const DeadReckoningReport_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DeadReckoningReport_

// alias to use template instance with default allocator
using DeadReckoningReport =
  dvl_msgs::msg::DeadReckoningReport_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace dvl_msgs

#endif  // DVL_MSGS__MSG__DETAIL__DEAD_RECKONING_REPORT__STRUCT_HPP_
