// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from dvl_msgs:msg/Transducer.idl
// generated code does not contain a copyright notice

#include "dvl_msgs/msg/detail/transducer__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_dvl_msgs
const rosidl_type_hash_t *
dvl_msgs__msg__Transducer__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x08, 0x69, 0x5d, 0x5f, 0xc3, 0x13, 0x10, 0x77,
      0xae, 0x85, 0xa2, 0xd8, 0x18, 0x32, 0xab, 0x0b,
      0x73, 0xbd, 0x91, 0x4d, 0xed, 0xca, 0xd3, 0xdf,
      0xa6, 0x8c, 0x6e, 0x3a, 0x2a, 0xfe, 0x34, 0xf5,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char dvl_msgs__msg__Transducer__TYPE_NAME[] = "dvl_msgs/msg/Transducer";

// Define type names, field names, and default values
static char dvl_msgs__msg__Transducer__FIELD_NAME__id[] = "id";
static char dvl_msgs__msg__Transducer__FIELD_NAME__velocity[] = "velocity";
static char dvl_msgs__msg__Transducer__FIELD_NAME__distance[] = "distance";
static char dvl_msgs__msg__Transducer__FIELD_NAME__rssi[] = "rssi";
static char dvl_msgs__msg__Transducer__FIELD_NAME__nsd[] = "nsd";

static rosidl_runtime_c__type_description__Field dvl_msgs__msg__Transducer__FIELDS[] = {
  {
    {dvl_msgs__msg__Transducer__FIELD_NAME__id, 2, 2},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_INT64,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {dvl_msgs__msg__Transducer__FIELD_NAME__velocity, 8, 8},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_DOUBLE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {dvl_msgs__msg__Transducer__FIELD_NAME__distance, 8, 8},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_DOUBLE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {dvl_msgs__msg__Transducer__FIELD_NAME__rssi, 4, 4},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_DOUBLE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {dvl_msgs__msg__Transducer__FIELD_NAME__nsd, 3, 3},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_DOUBLE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
dvl_msgs__msg__Transducer__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {dvl_msgs__msg__Transducer__TYPE_NAME, 23, 23},
      {dvl_msgs__msg__Transducer__FIELDS, 5, 5},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "int64 id # transducer number\n"
  "float64 velocity # velocity in the direction of the transducer in [m/s]\n"
  "float64 distance # distance parallel to the transducer beam to the reflecrting surface in [m]. -1 decodes invalid distance.\n"
  "float64 rssi # received signal strength indicator in [dBm]\n"
  "float64 nsd # noise spectral density in [dBm]";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
dvl_msgs__msg__Transducer__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {dvl_msgs__msg__Transducer__TYPE_NAME, 23, 23},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 330, 330},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
dvl_msgs__msg__Transducer__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *dvl_msgs__msg__Transducer__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
