// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from dvl_msgs:msg/Transducer.idl
// generated code does not contain a copyright notice

#ifndef DVL_MSGS__MSG__DETAIL__TRANSDUCER__STRUCT_H_
#define DVL_MSGS__MSG__DETAIL__TRANSDUCER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Struct defined in msg/Transducer in the package dvl_msgs.
typedef struct dvl_msgs__msg__Transducer
{
  /// transducer number
  int64_t id;
  /// velocity in the direction of the transducer in
  double velocity;
  /// distance parallel to the transducer beam to the reflecrting surface in. -1 decodes invalid distance.
  double distance;
  /// received signal strength indicator in
  double rssi;
  /// noise spectral density in
  double nsd;
} dvl_msgs__msg__Transducer;

// Struct for a sequence of dvl_msgs__msg__Transducer.
typedef struct dvl_msgs__msg__Transducer__Sequence
{
  dvl_msgs__msg__Transducer * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} dvl_msgs__msg__Transducer__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DVL_MSGS__MSG__DETAIL__TRANSDUCER__STRUCT_H_
