// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from dvl_msgs:msg/Velocity.idl
// generated code does not contain a copyright notice

#ifndef DVL_MSGS__MSG__DETAIL__VELOCITY__BUILDER_HPP_
#define DVL_MSGS__MSG__DETAIL__VELOCITY__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "dvl_msgs/msg/detail/velocity__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace dvl_msgs
{

namespace msg
{

namespace builder
{

class Init_Velocity_status
{
public:
  explicit Init_Velocity_status(::dvl_msgs::msg::Velocity & msg)
  : msg_(msg)
  {}
  ::dvl_msgs::msg::Velocity status(::dvl_msgs::msg::Velocity::_status_type arg)
  {
    msg_.status = std::move(arg);
    return std::move(msg_);
  }

private:
  ::dvl_msgs::msg::Velocity msg_;
};

class Init_Velocity_time_of_transmission
{
public:
  explicit Init_Velocity_time_of_transmission(::dvl_msgs::msg::Velocity & msg)
  : msg_(msg)
  {}
  Init_Velocity_status time_of_transmission(::dvl_msgs::msg::Velocity::_time_of_transmission_type arg)
  {
    msg_.time_of_transmission = std::move(arg);
    return Init_Velocity_status(msg_);
  }

private:
  ::dvl_msgs::msg::Velocity msg_;
};

class Init_Velocity_time_of_validity
{
public:
  explicit Init_Velocity_time_of_validity(::dvl_msgs::msg::Velocity & msg)
  : msg_(msg)
  {}
  Init_Velocity_time_of_transmission time_of_validity(::dvl_msgs::msg::Velocity::_time_of_validity_type arg)
  {
    msg_.time_of_validity = std::move(arg);
    return Init_Velocity_time_of_transmission(msg_);
  }

private:
  ::dvl_msgs::msg::Velocity msg_;
};

class Init_Velocity_altitude
{
public:
  explicit Init_Velocity_altitude(::dvl_msgs::msg::Velocity & msg)
  : msg_(msg)
  {}
  Init_Velocity_time_of_validity altitude(::dvl_msgs::msg::Velocity::_altitude_type arg)
  {
    msg_.altitude = std::move(arg);
    return Init_Velocity_time_of_validity(msg_);
  }

private:
  ::dvl_msgs::msg::Velocity msg_;
};

class Init_Velocity_covariance
{
public:
  explicit Init_Velocity_covariance(::dvl_msgs::msg::Velocity & msg)
  : msg_(msg)
  {}
  Init_Velocity_altitude covariance(::dvl_msgs::msg::Velocity::_covariance_type arg)
  {
    msg_.covariance = std::move(arg);
    return Init_Velocity_altitude(msg_);
  }

private:
  ::dvl_msgs::msg::Velocity msg_;
};

class Init_Velocity_figure_of_merit
{
public:
  explicit Init_Velocity_figure_of_merit(::dvl_msgs::msg::Velocity & msg)
  : msg_(msg)
  {}
  Init_Velocity_covariance figure_of_merit(::dvl_msgs::msg::Velocity::_figure_of_merit_type arg)
  {
    msg_.figure_of_merit = std::move(arg);
    return Init_Velocity_covariance(msg_);
  }

private:
  ::dvl_msgs::msg::Velocity msg_;
};

class Init_Velocity_velocity
{
public:
  explicit Init_Velocity_velocity(::dvl_msgs::msg::Velocity & msg)
  : msg_(msg)
  {}
  Init_Velocity_figure_of_merit velocity(::dvl_msgs::msg::Velocity::_velocity_type arg)
  {
    msg_.velocity = std::move(arg);
    return Init_Velocity_figure_of_merit(msg_);
  }

private:
  ::dvl_msgs::msg::Velocity msg_;
};

class Init_Velocity_valid
{
public:
  explicit Init_Velocity_valid(::dvl_msgs::msg::Velocity & msg)
  : msg_(msg)
  {}
  Init_Velocity_velocity valid(::dvl_msgs::msg::Velocity::_valid_type arg)
  {
    msg_.valid = std::move(arg);
    return Init_Velocity_velocity(msg_);
  }

private:
  ::dvl_msgs::msg::Velocity msg_;
};

class Init_Velocity_time_ms
{
public:
  Init_Velocity_time_ms()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_Velocity_valid time_ms(::dvl_msgs::msg::Velocity::_time_ms_type arg)
  {
    msg_.time_ms = std::move(arg);
    return Init_Velocity_valid(msg_);
  }

private:
  ::dvl_msgs::msg::Velocity msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::dvl_msgs::msg::Velocity>()
{
  return dvl_msgs::msg::builder::Init_Velocity_time_ms();
}

}  // namespace dvl_msgs

#endif  // DVL_MSGS__MSG__DETAIL__VELOCITY__BUILDER_HPP_
