// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from dvl_msgs:msg/Velocity.idl
// generated code does not contain a copyright notice
#include "dvl_msgs/msg/detail/velocity__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `velocity`
#include "geometry_msgs/msg/detail/vector3__functions.h"

bool
dvl_msgs__msg__Velocity__init(dvl_msgs__msg__Velocity * msg)
{
  if (!msg) {
    return false;
  }
  // time_ms
  // valid
  // velocity
  if (!geometry_msgs__msg__Vector3__init(&msg->velocity)) {
    dvl_msgs__msg__Velocity__fini(msg);
    return false;
  }
  // figure_of_merit
  // covariance
  // altitude
  // time_of_validity
  // time_of_transmission
  // status
  return true;
}

void
dvl_msgs__msg__Velocity__fini(dvl_msgs__msg__Velocity * msg)
{
  if (!msg) {
    return;
  }
  // time_ms
  // valid
  // velocity
  geometry_msgs__msg__Vector3__fini(&msg->velocity);
  // figure_of_merit
  // covariance
  // altitude
  // time_of_validity
  // time_of_transmission
  // status
}

bool
dvl_msgs__msg__Velocity__are_equal(const dvl_msgs__msg__Velocity * lhs, const dvl_msgs__msg__Velocity * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // time_ms
  if (lhs->time_ms != rhs->time_ms) {
    return false;
  }
  // valid
  if (lhs->valid != rhs->valid) {
    return false;
  }
  // velocity
  if (!geometry_msgs__msg__Vector3__are_equal(
      &(lhs->velocity), &(rhs->velocity)))
  {
    return false;
  }
  // figure_of_merit
  if (lhs->figure_of_merit != rhs->figure_of_merit) {
    return false;
  }
  // covariance
  for (size_t i = 0; i < 9; ++i) {
    if (lhs->covariance[i] != rhs->covariance[i]) {
      return false;
    }
  }
  // altitude
  if (lhs->altitude != rhs->altitude) {
    return false;
  }
  // time_of_validity
  if (lhs->time_of_validity != rhs->time_of_validity) {
    return false;
  }
  // time_of_transmission
  if (lhs->time_of_transmission != rhs->time_of_transmission) {
    return false;
  }
  // status
  if (lhs->status != rhs->status) {
    return false;
  }
  return true;
}

bool
dvl_msgs__msg__Velocity__copy(
  const dvl_msgs__msg__Velocity * input,
  dvl_msgs__msg__Velocity * output)
{
  if (!input || !output) {
    return false;
  }
  // time_ms
  output->time_ms = input->time_ms;
  // valid
  output->valid = input->valid;
  // velocity
  if (!geometry_msgs__msg__Vector3__copy(
      &(input->velocity), &(output->velocity)))
  {
    return false;
  }
  // figure_of_merit
  output->figure_of_merit = input->figure_of_merit;
  // covariance
  for (size_t i = 0; i < 9; ++i) {
    output->covariance[i] = input->covariance[i];
  }
  // altitude
  output->altitude = input->altitude;
  // time_of_validity
  output->time_of_validity = input->time_of_validity;
  // time_of_transmission
  output->time_of_transmission = input->time_of_transmission;
  // status
  output->status = input->status;
  return true;
}

dvl_msgs__msg__Velocity *
dvl_msgs__msg__Velocity__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dvl_msgs__msg__Velocity * msg = (dvl_msgs__msg__Velocity *)allocator.allocate(sizeof(dvl_msgs__msg__Velocity), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(dvl_msgs__msg__Velocity));
  bool success = dvl_msgs__msg__Velocity__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
dvl_msgs__msg__Velocity__destroy(dvl_msgs__msg__Velocity * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    dvl_msgs__msg__Velocity__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
dvl_msgs__msg__Velocity__Sequence__init(dvl_msgs__msg__Velocity__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dvl_msgs__msg__Velocity * data = NULL;

  if (size) {
    data = (dvl_msgs__msg__Velocity *)allocator.zero_allocate(size, sizeof(dvl_msgs__msg__Velocity), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = dvl_msgs__msg__Velocity__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        dvl_msgs__msg__Velocity__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
dvl_msgs__msg__Velocity__Sequence__fini(dvl_msgs__msg__Velocity__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      dvl_msgs__msg__Velocity__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

dvl_msgs__msg__Velocity__Sequence *
dvl_msgs__msg__Velocity__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  dvl_msgs__msg__Velocity__Sequence * array = (dvl_msgs__msg__Velocity__Sequence *)allocator.allocate(sizeof(dvl_msgs__msg__Velocity__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = dvl_msgs__msg__Velocity__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
dvl_msgs__msg__Velocity__Sequence__destroy(dvl_msgs__msg__Velocity__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    dvl_msgs__msg__Velocity__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
dvl_msgs__msg__Velocity__Sequence__are_equal(const dvl_msgs__msg__Velocity__Sequence * lhs, const dvl_msgs__msg__Velocity__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!dvl_msgs__msg__Velocity__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
dvl_msgs__msg__Velocity__Sequence__copy(
  const dvl_msgs__msg__Velocity__Sequence * input,
  dvl_msgs__msg__Velocity__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(dvl_msgs__msg__Velocity);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    dvl_msgs__msg__Velocity * data =
      (dvl_msgs__msg__Velocity *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!dvl_msgs__msg__Velocity__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          dvl_msgs__msg__Velocity__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!dvl_msgs__msg__Velocity__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
