// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from dvl_msgs:msg/Velocity.idl
// generated code does not contain a copyright notice

#ifndef DVL_MSGS__MSG__DETAIL__VELOCITY__STRUCT_H_
#define DVL_MSGS__MSG__DETAIL__VELOCITY__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'velocity'
#include "geometry_msgs/msg/detail/vector3__struct.h"

/// Struct defined in msg/Velocity in the package dvl_msgs.
typedef struct dvl_msgs__msg__Velocity
{
  /// time since last report in ms
  uint64_t time_ms;
  bool valid;
  geometry_msgs__msg__Vector3 velocity;
  /// Figure of merit in
  double figure_of_merit;
  /// in
  double covariance[9];
  double altitude;
  /// timestamp of the surface reflection, i.e. 'center of ping' in
  uint64_t time_of_validity;
  /// in
  uint64_t time_of_transmission;
  /// status flags
  uint8_t status;
} dvl_msgs__msg__Velocity;

// Struct for a sequence of dvl_msgs__msg__Velocity.
typedef struct dvl_msgs__msg__Velocity__Sequence
{
  dvl_msgs__msg__Velocity * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} dvl_msgs__msg__Velocity__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DVL_MSGS__MSG__DETAIL__VELOCITY__STRUCT_H_
