// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from dvl_msgs:msg/Velocity.idl
// generated code does not contain a copyright notice

#ifndef DVL_MSGS__MSG__DETAIL__VELOCITY__STRUCT_HPP_
#define DVL_MSGS__MSG__DETAIL__VELOCITY__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'velocity'
#include "geometry_msgs/msg/detail/vector3__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__dvl_msgs__msg__Velocity __attribute__((deprecated))
#else
# define DEPRECATED__dvl_msgs__msg__Velocity __declspec(deprecated)
#endif

namespace dvl_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Velocity_
{
  using Type = Velocity_<ContainerAllocator>;

  explicit Velocity_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : velocity(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->time_ms = 0ull;
      this->valid = false;
      this->figure_of_merit = 0.0;
      std::fill<typename std::array<double, 9>::iterator, double>(this->covariance.begin(), this->covariance.end(), 0.0);
      this->altitude = 0.0;
      this->time_of_validity = 0ull;
      this->time_of_transmission = 0ull;
      this->status = 0;
    }
  }

  explicit Velocity_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : velocity(_alloc, _init),
    covariance(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->time_ms = 0ull;
      this->valid = false;
      this->figure_of_merit = 0.0;
      std::fill<typename std::array<double, 9>::iterator, double>(this->covariance.begin(), this->covariance.end(), 0.0);
      this->altitude = 0.0;
      this->time_of_validity = 0ull;
      this->time_of_transmission = 0ull;
      this->status = 0;
    }
  }

  // field types and members
  using _time_ms_type =
    uint64_t;
  _time_ms_type time_ms;
  using _valid_type =
    bool;
  _valid_type valid;
  using _velocity_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _velocity_type velocity;
  using _figure_of_merit_type =
    double;
  _figure_of_merit_type figure_of_merit;
  using _covariance_type =
    std::array<double, 9>;
  _covariance_type covariance;
  using _altitude_type =
    double;
  _altitude_type altitude;
  using _time_of_validity_type =
    uint64_t;
  _time_of_validity_type time_of_validity;
  using _time_of_transmission_type =
    uint64_t;
  _time_of_transmission_type time_of_transmission;
  using _status_type =
    uint8_t;
  _status_type status;

  // setters for named parameter idiom
  Type & set__time_ms(
    const uint64_t & _arg)
  {
    this->time_ms = _arg;
    return *this;
  }
  Type & set__valid(
    const bool & _arg)
  {
    this->valid = _arg;
    return *this;
  }
  Type & set__velocity(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->velocity = _arg;
    return *this;
  }
  Type & set__figure_of_merit(
    const double & _arg)
  {
    this->figure_of_merit = _arg;
    return *this;
  }
  Type & set__covariance(
    const std::array<double, 9> & _arg)
  {
    this->covariance = _arg;
    return *this;
  }
  Type & set__altitude(
    const double & _arg)
  {
    this->altitude = _arg;
    return *this;
  }
  Type & set__time_of_validity(
    const uint64_t & _arg)
  {
    this->time_of_validity = _arg;
    return *this;
  }
  Type & set__time_of_transmission(
    const uint64_t & _arg)
  {
    this->time_of_transmission = _arg;
    return *this;
  }
  Type & set__status(
    const uint8_t & _arg)
  {
    this->status = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    dvl_msgs::msg::Velocity_<ContainerAllocator> *;
  using ConstRawPtr =
    const dvl_msgs::msg::Velocity_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dvl_msgs::msg::Velocity_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dvl_msgs::msg::Velocity_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dvl_msgs::msg::Velocity_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dvl_msgs::msg::Velocity_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dvl_msgs::msg::Velocity_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dvl_msgs::msg::Velocity_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dvl_msgs::msg::Velocity_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dvl_msgs::msg::Velocity_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__dvl_msgs__msg__Velocity
    std::shared_ptr<dvl_msgs::msg::Velocity_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__dvl_msgs__msg__Velocity
    std::shared_ptr<dvl_msgs::msg::Velocity_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Velocity_ & other) const
  {
    if (this->time_ms != other.time_ms) {
      return false;
    }
    if (this->valid != other.valid) {
      return false;
    }
    if (this->velocity != other.velocity) {
      return false;
    }
    if (this->figure_of_merit != other.figure_of_merit) {
      return false;
    }
    if (this->covariance != other.covariance) {
      return false;
    }
    if (this->altitude != other.altitude) {
      return false;
    }
    if (this->time_of_validity != other.time_of_validity) {
      return false;
    }
    if (this->time_of_transmission != other.time_of_transmission) {
      return false;
    }
    if (this->status != other.status) {
      return false;
    }
    return true;
  }
  bool operator!=(const Velocity_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Velocity_

// alias to use template instance with default allocator
using Velocity =
  dvl_msgs::msg::Velocity_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace dvl_msgs

#endif  // DVL_MSGS__MSG__DETAIL__VELOCITY__STRUCT_HPP_
