// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from dvl_msgs:msg/VelocityTransducerReport.idl
// generated code does not contain a copyright notice

#ifndef DVL_MSGS__MSG__DETAIL__VELOCITY_TRANSDUCER_REPORT__STRUCT_HPP_
#define DVL_MSGS__MSG__DETAIL__VELOCITY_TRANSDUCER_REPORT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'transducers'
#include "dvl_msgs/msg/detail/transducer__struct.hpp"
// Member 'velocity'
#include "dvl_msgs/msg/detail/velocity__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__dvl_msgs__msg__VelocityTransducerReport __attribute__((deprecated))
#else
# define DEPRECATED__dvl_msgs__msg__VelocityTransducerReport __declspec(deprecated)
#endif

namespace dvl_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct VelocityTransducerReport_
{
  using Type = VelocityTransducerReport_<ContainerAllocator>;

  explicit VelocityTransducerReport_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    velocity(_init)
  {
    (void)_init;
  }

  explicit VelocityTransducerReport_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    velocity(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _transducers_type =
    std::vector<dvl_msgs::msg::Transducer_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<dvl_msgs::msg::Transducer_<ContainerAllocator>>>;
  _transducers_type transducers;
  using _velocity_type =
    dvl_msgs::msg::Velocity_<ContainerAllocator>;
  _velocity_type velocity;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__transducers(
    const std::vector<dvl_msgs::msg::Transducer_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<dvl_msgs::msg::Transducer_<ContainerAllocator>>> & _arg)
  {
    this->transducers = _arg;
    return *this;
  }
  Type & set__velocity(
    const dvl_msgs::msg::Velocity_<ContainerAllocator> & _arg)
  {
    this->velocity = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    dvl_msgs::msg::VelocityTransducerReport_<ContainerAllocator> *;
  using ConstRawPtr =
    const dvl_msgs::msg::VelocityTransducerReport_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dvl_msgs::msg::VelocityTransducerReport_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dvl_msgs::msg::VelocityTransducerReport_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dvl_msgs::msg::VelocityTransducerReport_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dvl_msgs::msg::VelocityTransducerReport_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dvl_msgs::msg::VelocityTransducerReport_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dvl_msgs::msg::VelocityTransducerReport_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dvl_msgs::msg::VelocityTransducerReport_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dvl_msgs::msg::VelocityTransducerReport_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__dvl_msgs__msg__VelocityTransducerReport
    std::shared_ptr<dvl_msgs::msg::VelocityTransducerReport_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__dvl_msgs__msg__VelocityTransducerReport
    std::shared_ptr<dvl_msgs::msg::VelocityTransducerReport_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VelocityTransducerReport_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->transducers != other.transducers) {
      return false;
    }
    if (this->velocity != other.velocity) {
      return false;
    }
    return true;
  }
  bool operator!=(const VelocityTransducerReport_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VelocityTransducerReport_

// alias to use template instance with default allocator
using VelocityTransducerReport =
  dvl_msgs::msg::VelocityTransducerReport_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace dvl_msgs

#endif  // DVL_MSGS__MSG__DETAIL__VELOCITY_TRANSDUCER_REPORT__STRUCT_HPP_
