// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from dvl_msgs:srv/GetConfig.idl
// generated code does not contain a copyright notice

#ifndef DVL_MSGS__SRV__DETAIL__GET_CONFIG__STRUCT_H_
#define DVL_MSGS__SRV__DETAIL__GET_CONFIG__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in srv/GetConfig in the package dvl_msgs.
typedef struct dvl_msgs__srv__GetConfig_Request
{
  uint8_t structure_needs_at_least_one_member;
} dvl_msgs__srv__GetConfig_Request;

// Struct for a sequence of dvl_msgs__srv__GetConfig_Request.
typedef struct dvl_msgs__srv__GetConfig_Request__Sequence
{
  dvl_msgs__srv__GetConfig_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} dvl_msgs__srv__GetConfig_Request__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'message'
#include "rosidl_runtime_c/string.h"
// Member 'result'
#include "dvl_msgs/msg/detail/config_result__struct.h"

/// Struct defined in srv/GetConfig in the package dvl_msgs.
typedef struct dvl_msgs__srv__GetConfig_Response
{
  bool success;
  rosidl_runtime_c__String message;
  dvl_msgs__msg__ConfigResult result;
} dvl_msgs__srv__GetConfig_Response;

// Struct for a sequence of dvl_msgs__srv__GetConfig_Response.
typedef struct dvl_msgs__srv__GetConfig_Response__Sequence
{
  dvl_msgs__srv__GetConfig_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} dvl_msgs__srv__GetConfig_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  dvl_msgs__srv__GetConfig_Event__request__MAX_SIZE = 1
};
// response
enum
{
  dvl_msgs__srv__GetConfig_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/GetConfig in the package dvl_msgs.
typedef struct dvl_msgs__srv__GetConfig_Event
{
  service_msgs__msg__ServiceEventInfo info;
  dvl_msgs__srv__GetConfig_Request__Sequence request;
  dvl_msgs__srv__GetConfig_Response__Sequence response;
} dvl_msgs__srv__GetConfig_Event;

// Struct for a sequence of dvl_msgs__srv__GetConfig_Event.
typedef struct dvl_msgs__srv__GetConfig_Event__Sequence
{
  dvl_msgs__srv__GetConfig_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} dvl_msgs__srv__GetConfig_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DVL_MSGS__SRV__DETAIL__GET_CONFIG__STRUCT_H_
