// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from dvl_msgs:srv/GetConfig.idl
// generated code does not contain a copyright notice

#ifndef DVL_MSGS__SRV__DETAIL__GET_CONFIG__STRUCT_HPP_
#define DVL_MSGS__SRV__DETAIL__GET_CONFIG__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__dvl_msgs__srv__GetConfig_Request __attribute__((deprecated))
#else
# define DEPRECATED__dvl_msgs__srv__GetConfig_Request __declspec(deprecated)
#endif

namespace dvl_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetConfig_Request_
{
  using Type = GetConfig_Request_<ContainerAllocator>;

  explicit GetConfig_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  explicit GetConfig_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  // field types and members
  using _structure_needs_at_least_one_member_type =
    uint8_t;
  _structure_needs_at_least_one_member_type structure_needs_at_least_one_member;


  // constant declarations

  // pointer types
  using RawPtr =
    dvl_msgs::srv::GetConfig_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const dvl_msgs::srv::GetConfig_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dvl_msgs::srv::GetConfig_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dvl_msgs::srv::GetConfig_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dvl_msgs::srv::GetConfig_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dvl_msgs::srv::GetConfig_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dvl_msgs::srv::GetConfig_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dvl_msgs::srv::GetConfig_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dvl_msgs::srv::GetConfig_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dvl_msgs::srv::GetConfig_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__dvl_msgs__srv__GetConfig_Request
    std::shared_ptr<dvl_msgs::srv::GetConfig_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__dvl_msgs__srv__GetConfig_Request
    std::shared_ptr<dvl_msgs::srv::GetConfig_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetConfig_Request_ & other) const
  {
    if (this->structure_needs_at_least_one_member != other.structure_needs_at_least_one_member) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetConfig_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetConfig_Request_

// alias to use template instance with default allocator
using GetConfig_Request =
  dvl_msgs::srv::GetConfig_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace dvl_msgs


// Include directives for member types
// Member 'result'
#include "dvl_msgs/msg/detail/config_result__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__dvl_msgs__srv__GetConfig_Response __attribute__((deprecated))
#else
# define DEPRECATED__dvl_msgs__srv__GetConfig_Response __declspec(deprecated)
#endif

namespace dvl_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetConfig_Response_
{
  using Type = GetConfig_Response_<ContainerAllocator>;

  explicit GetConfig_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->message = "";
    }
  }

  explicit GetConfig_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : message(_alloc),
    result(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->message = "";
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;
  using _message_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _message_type message;
  using _result_type =
    dvl_msgs::msg::ConfigResult_<ContainerAllocator>;
  _result_type result;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }
  Type & set__message(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->message = _arg;
    return *this;
  }
  Type & set__result(
    const dvl_msgs::msg::ConfigResult_<ContainerAllocator> & _arg)
  {
    this->result = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    dvl_msgs::srv::GetConfig_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const dvl_msgs::srv::GetConfig_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dvl_msgs::srv::GetConfig_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dvl_msgs::srv::GetConfig_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dvl_msgs::srv::GetConfig_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dvl_msgs::srv::GetConfig_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dvl_msgs::srv::GetConfig_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dvl_msgs::srv::GetConfig_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dvl_msgs::srv::GetConfig_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dvl_msgs::srv::GetConfig_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__dvl_msgs__srv__GetConfig_Response
    std::shared_ptr<dvl_msgs::srv::GetConfig_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__dvl_msgs__srv__GetConfig_Response
    std::shared_ptr<dvl_msgs::srv::GetConfig_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetConfig_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    if (this->message != other.message) {
      return false;
    }
    if (this->result != other.result) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetConfig_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetConfig_Response_

// alias to use template instance with default allocator
using GetConfig_Response =
  dvl_msgs::srv::GetConfig_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace dvl_msgs


// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__dvl_msgs__srv__GetConfig_Event __attribute__((deprecated))
#else
# define DEPRECATED__dvl_msgs__srv__GetConfig_Event __declspec(deprecated)
#endif

namespace dvl_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetConfig_Event_
{
  using Type = GetConfig_Event_<ContainerAllocator>;

  explicit GetConfig_Event_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_init)
  {
    (void)_init;
  }

  explicit GetConfig_Event_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _info_type =
    service_msgs::msg::ServiceEventInfo_<ContainerAllocator>;
  _info_type info;
  using _request_type =
    rosidl_runtime_cpp::BoundedVector<dvl_msgs::srv::GetConfig_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<dvl_msgs::srv::GetConfig_Request_<ContainerAllocator>>>;
  _request_type request;
  using _response_type =
    rosidl_runtime_cpp::BoundedVector<dvl_msgs::srv::GetConfig_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<dvl_msgs::srv::GetConfig_Response_<ContainerAllocator>>>;
  _response_type response;

  // setters for named parameter idiom
  Type & set__info(
    const service_msgs::msg::ServiceEventInfo_<ContainerAllocator> & _arg)
  {
    this->info = _arg;
    return *this;
  }
  Type & set__request(
    const rosidl_runtime_cpp::BoundedVector<dvl_msgs::srv::GetConfig_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<dvl_msgs::srv::GetConfig_Request_<ContainerAllocator>>> & _arg)
  {
    this->request = _arg;
    return *this;
  }
  Type & set__response(
    const rosidl_runtime_cpp::BoundedVector<dvl_msgs::srv::GetConfig_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<dvl_msgs::srv::GetConfig_Response_<ContainerAllocator>>> & _arg)
  {
    this->response = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    dvl_msgs::srv::GetConfig_Event_<ContainerAllocator> *;
  using ConstRawPtr =
    const dvl_msgs::srv::GetConfig_Event_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dvl_msgs::srv::GetConfig_Event_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dvl_msgs::srv::GetConfig_Event_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dvl_msgs::srv::GetConfig_Event_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dvl_msgs::srv::GetConfig_Event_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dvl_msgs::srv::GetConfig_Event_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dvl_msgs::srv::GetConfig_Event_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dvl_msgs::srv::GetConfig_Event_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dvl_msgs::srv::GetConfig_Event_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__dvl_msgs__srv__GetConfig_Event
    std::shared_ptr<dvl_msgs::srv::GetConfig_Event_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__dvl_msgs__srv__GetConfig_Event
    std::shared_ptr<dvl_msgs::srv::GetConfig_Event_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetConfig_Event_ & other) const
  {
    if (this->info != other.info) {
      return false;
    }
    if (this->request != other.request) {
      return false;
    }
    if (this->response != other.response) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetConfig_Event_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetConfig_Event_

// alias to use template instance with default allocator
using GetConfig_Event =
  dvl_msgs::srv::GetConfig_Event_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace dvl_msgs

namespace dvl_msgs
{

namespace srv
{

struct GetConfig
{
  using Request = dvl_msgs::srv::GetConfig_Request;
  using Response = dvl_msgs::srv::GetConfig_Response;
  using Event = dvl_msgs::srv::GetConfig_Event;
};

}  // namespace srv

}  // namespace dvl_msgs

#endif  // DVL_MSGS__SRV__DETAIL__GET_CONFIG__STRUCT_HPP_
