// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from dvl_msgs:srv/SetSpeedOfSound.idl
// generated code does not contain a copyright notice

#ifndef DVL_MSGS__SRV__DETAIL__SET_SPEED_OF_SOUND__STRUCT_H_
#define DVL_MSGS__SRV__DETAIL__SET_SPEED_OF_SOUND__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in srv/SetSpeedOfSound in the package dvl_msgs.
typedef struct dvl_msgs__srv__SetSpeedOfSound_Request
{
  double speed_of_sound;
} dvl_msgs__srv__SetSpeedOfSound_Request;

// Struct for a sequence of dvl_msgs__srv__SetSpeedOfSound_Request.
typedef struct dvl_msgs__srv__SetSpeedOfSound_Request__Sequence
{
  dvl_msgs__srv__SetSpeedOfSound_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} dvl_msgs__srv__SetSpeedOfSound_Request__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'message'
#include "rosidl_runtime_c/string.h"

/// Struct defined in srv/SetSpeedOfSound in the package dvl_msgs.
typedef struct dvl_msgs__srv__SetSpeedOfSound_Response
{
  bool success;
  rosidl_runtime_c__String message;
} dvl_msgs__srv__SetSpeedOfSound_Response;

// Struct for a sequence of dvl_msgs__srv__SetSpeedOfSound_Response.
typedef struct dvl_msgs__srv__SetSpeedOfSound_Response__Sequence
{
  dvl_msgs__srv__SetSpeedOfSound_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} dvl_msgs__srv__SetSpeedOfSound_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  dvl_msgs__srv__SetSpeedOfSound_Event__request__MAX_SIZE = 1
};
// response
enum
{
  dvl_msgs__srv__SetSpeedOfSound_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/SetSpeedOfSound in the package dvl_msgs.
typedef struct dvl_msgs__srv__SetSpeedOfSound_Event
{
  service_msgs__msg__ServiceEventInfo info;
  dvl_msgs__srv__SetSpeedOfSound_Request__Sequence request;
  dvl_msgs__srv__SetSpeedOfSound_Response__Sequence response;
} dvl_msgs__srv__SetSpeedOfSound_Event;

// Struct for a sequence of dvl_msgs__srv__SetSpeedOfSound_Event.
typedef struct dvl_msgs__srv__SetSpeedOfSound_Event__Sequence
{
  dvl_msgs__srv__SetSpeedOfSound_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} dvl_msgs__srv__SetSpeedOfSound_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DVL_MSGS__SRV__DETAIL__SET_SPEED_OF_SOUND__STRUCT_H_
